/************************************************************************
**
** @(#)bgibase.h		11/17/94		Chris Ahlstrom
**
** ---------------------------
**  73340.26@compuserve.com
** ---------------------------
**
**	C++; edit with tab-stops = 4.
**
**		Defines the BGIManager class.
**
*************************************************************************/

#if !defined(BGIBASE_h)									// { BGIBASE_h
#define BGIBASE_h

#include "rbox_int.h"		// ResponseBoxInterior class
#include "points.h"			// Rectangle class
#include "scrcombo.h"		// ScreenCombo type


/************************************************************************
** BGIManager
*************************************************************************/

class BGIManager
{

public:

	BGIManager							// constructor
	(
		ScreenCombo combo
	);

	virtual ~BGIManager ();				// destructor

	int graphicsOK ();
	ScreenCombo monitorType ()
	{
		return monitorCombo;
	}

	void lightAspectConvert				// converts a light to text units
	(
		const Rectangle &wbox,			// window box into which light goes
		ResponseBoxLight &light,		// pixel-coordinates of light
		ResponseBoxLight &text			// text-coordinate-offsets of light
	);
	void textAspectConvert				// converts text to text units
	(
		const Rectangle &wbox,			// window box into which light goes
		ResponseBoxText &light,			// pixel-coordinates of light
		ResponseBoxText &text			// text-coordinate-offsets of light
	);
	int screenX
	(
		int hercx
	);
	int screenY
	(
		int hercy
	);
	int mouseX
	(
		int vgax
	);
	int mouseY
	(
		int vgay
	);
	int hercX
	(
		int mousex
	);
	int hercY
	(
		int mousey
	);

protected:

	enum graphics_errors graphicsUp
	(
		ScreenCombo combo				// which type of screen to use
	);

protected:

	int respRows;
	int respColumns;
	int respPixelX;
	int respPixelY;
	int graphicsReady;
	ScreenCombo monitorCombo;			// color/mono monitor combination

};


#endif													// } BGIBASE_h
