/************************************************************************
**
** @(#)math_aux.h		10/12/94		Chris Ahlstrom
**
**		Additional useful math routines from math_aux.c.
**
*************************************************************************/


#ifndef MATH_AUX_h						/* { MATH_AUX_h definition	*/
#define MATH_AUX_h

#include <math.h>

#define PI				3.14159265358979323846264338
#define HUGE_LONG_INT	 2147483647L
#define LOW_LONG_INT	-2147483648L

#define ln(x)					log(x)
#define expon(base, ex)			exp((ex) * log(base))

extern long round				/* round up to a long value				*/
(
	double x					/* the value to round up				*/
);
extern int iround				/* round up to an int value				*/
(
	double x					/* the value to round up				*/
);
extern unsigned long dtoul		/* pack a double for Windows message	*/
(
	double x					/* the number to pack					*/
);
extern double ultod				/* unpack a packed double back to long	*/
(
	unsigned long x				/* the number to unpack					*/
);
extern char *itoa10				/* convert a number to a base-10 string	*/
(
	int number,					/* the number to convert				*/
	char *string,				/* destination string					*/
	int digits					/* minimum number of digits				*/
);
extern int *random_integers		/* array of random integers				*/
(
	int siz
);


#endif									/* } MATH_AUX_h definition	*/
