/************************************************************************
**
** @(#)msptbutt.cpp		11/16/94	Chris Ahlstrom
**
**		Derived from MouseResponseButton (module msrbutt), this version
** modifies readKey() to return the coordinates of the mouse when
** left-clicked.  A right-click should be an abort.
**
**		I BELIEVE THIS MODULE CAN GO AWAY, SINCE WE JUST HAD TO
**		UPGRADE msrbutt.cpp/h TO GET COORDINATE FUNCTIONALITY.
**
*************************************************************************/

#define MSPTBUTT_cpp

#include <conio.h>			// getch() function for keyboard usage
#include <ctype.h>			// toupper() function for keyboard usage

#include "msptbutt.h"		// MousePointResponseButton class

extern "C"
{
	#include "tmouse.h"		// a few mouse routines [readMouseButtons()]
}



/************************************************************************
** MousePointResponseButton constructor
*************************************************************************/

MousePointResponseButton::MousePointResponseButton
(
	ResponseType buttontype
)
  :
	MouseResponseButton			(buttontype)	// base class
{
}


MousePointResponseButton::~MousePointResponseButton ()
{
}


/************************************************************************
** readKey() override
**
**	Function to read the mouse buttons.
**
**	button is a bitmask; the following values apply:
**
**		  Bit   Meaning if on
**		 -----  --------------------------------------------
**		0 = left button is down (LEFT_MOUSEBUTTON)
**		1 = right button is down (RIGHT_MOUSEBUTTON)
**		2 = center button is down (CENTER_MOUSEBUTTON)
**		3 to 15 are reserved
**
**	See the Response typedef in rbuttons.h.
**
*************************************************************************/

int
MousePointResponseButton::readKey ()
{
	int button;
	
	button = specialKey();			// check keyboard first

	if (button == 0)
	{
		if (twoButtonsProhibited)
		{
			do
			{
				button = readMouseButtons();

			} while (button == (LEFT_MOUSEBUTTON | RIGHT_MOUSEBUTTON));
		}
		else
			button = readMouseButtons();
	}
	lastResponse = (Response) button;

	return button;
}  



/************************************************************************
** specialKey()
**
**		This default implementation supports input from the keyboard;
** the buttons (keys, here) to achieve each status are listed in
** square brackets.
**
**		specialkey() returns the following statuses (see Response in
** rbuttons.h).  More will be added later:
**
**		0 if no button is pressed
**		1 if button 1 is pressed				[key '1']
**		2 if button 2 is pressed				[key '2']
**		3 if both buttons are pressed			[key 'b' or ESC]
**
*************************************************************************/

int
MousePointResponseButton::specialKey ()
{
	int button = (int) NO_BUTTON;

	if (kbhit())
	{
		button = getch();
		if (button == KEY_BUTTON_1)
			button = (int) BUTTON_1;
		else if (button == KEY_BUTTON_2)
			button = (int) BUTTON_2;
		else
		{
			button = toupper(button);
			if (button == KEY_BOTH_BUTTONS || button == KEY_BOTH_ESCAPE)
				button = (int) BOTH_BUTTONS;
		}
	}
	lastResponse = (Response) button;
	return button;
}
