/************************************************************************
**
** @(#)rbox_dbg.h		11/11/94		Chris Ahlstrom
**
** ---------------------------
**  73340.26@compuserve.com
** ---------------------------
**
**	C++
**
**	Edit this module with tab-stops of 4.
**
**		This module supports generic response-box devices.  It should
** supercede the ResponseDevice class, which was very restrictive.
** The modules to supercede are:
**
**		RBUTTONS
**		RESPWIND
**
**		The model for a ResponseBGIDevice is pretty simple.  We have
** manipulator functions that call functions for the response-button
** and response-light-drawing classes.
**
*************************************************************************/

#if !defined(RBOX_DBG_h)								// { RBOX_DBG_h
#define RBOX_DBG_h


#include "rbuttons.h"		// ResponseButton class
#include "rbox_bas.h"		// ResponseBoxDeviceBase class
#include "rbox_bgi.h"		// ResponseBGIInterior class


/************************************************************************
** ResponseBGIDevice
**
**		We override the version of startScreen, in
** in order to provide the extra function of waiting for the user.
**
**		We add a responseFeedback() routine to wait for a key press
** and show the feedback lights.
**
*************************************************************************/

class ResponseBGIDevice	: public ResponseBoxDeviceBase
{

public:

	ResponseBGIDevice
	(
		ResponseType device,
		const Rectangle &bounds,
		const char *atitle,
		ScreenCombo combo,
		ResponseFeature style = RF_STANDARD,	// response-box style
		int intervalcount = -1					// number of intervals (1 to 3)
	);

	virtual ~ResponseBGIDevice();

private:

	void setupBoxLights
	(
		int intervalcount
	);
	int xLocation
	(
		double eighths
	);

};


#endif													// } RBOX_DBG_h
