/************************************************************************
**
** @(#)rbox_tvi.h		06/21/94		Chris Ahlstrom
**
** ---------------------------
**  73340.26@compuserve.com
** ---------------------------
**
**	C++
**
**	Edit with tab-stops = 4.
**
**		Defines the ResponseTVInterior class.  We can't derive it from
** both a ResponseBoxInterior and a TView (at least, I don't think we
** can), so we include TView functionality in the tvInterior member,
** have to pass information down to this member.
**
*************************************************************************/

#if !defined(RBOX_TVI_h)								// { RBOX_TVI_h
#define RBOX_TVI_h

#include "rbox_int.h"		// ResponseBoxInterior class
#include "rbox_tv.h"		// ResponseBoxTView class


/************************************************************************
** ResponseTVInterior
**
**		Since a ResponseBox is allocated in the constructor, we really
** need to add an assignment operator and copy constructor. Later...
** (famous last word).  Or make them private.
**
**		This ResponseBoxInterior doesn't have to do much real work.
** Turbo Vision does all the work, and the interior just has to pass
** on some status information to the TView (Turbo Vision) object.
**
*************************************************************************/

class ResponseTVInterior : public ResponseBoxInterior
{

public:

	ResponseTVInterior						// constructor
	(
		TRect &bounds
	);

	~ResponseTVInterior ();					// destructor

	virtual int drawThis ();				// override

public:										// pure virtual functions

	virtual int drawSpecial					// redraw special light
	(
		int lightnumber,
		unsigned onstate
	);
	virtual int drawText
	(
		unsigned lpboffset,
		unsigned onstate
	);
	virtual int drawGraphic
	(
		unsigned lpboffset,
		unsigned onstate
	);

public:

	ResponseBoxTView tvInterior;

};


#endif													// } RBOX_TVI_h
