/************************************************************************
**
** @(#)scrcombo.h		01/07/96		Chris Ahlstrom
**
** ---------------------------
**  73340.26@compuserve.com
** ---------------------------
**
**	C++
**
**	Edit with tab-stops = 4.
**
**		Defines the ScreenCombo and ResponseFeature enumerations.
**
*************************************************************************/

#if !defined(SCRCOMBO_h)								// { SCRCOMBO_h
#define SCRCOMBO_h


/************************************************************************
** ScreenCombo
**
**	This enum makes it easy to select the very few conditions
** of video access we need.  We need to support two kinds of monitor
** system, and we might throw a couple of others in for good measure:
**
**	o	Graphics on the main monitor.  This is used mostly
**		for debugging the experiment-software.  It requires
**		EGAVGI.BGI to be converted to an object module and
**		linked to the program, as done in the PSI makefile.
**
**	o	Graphics on the monochrome monitor, without effacing
**		the main monitor.  This is heavily used.  It requires
**		a specially-patched version of HERC.BGI, processed as
**		done in the makefile.  The regular HERC.BGI can be
**		used, but it renders the main screen blank!
**
**	The font is also part of the ScreenCombo, though it might
** be the same for both combos.
**
*************************************************************************/

typedef enum
{
    BGI_USE_MAIN_VGA	= 0,	// use the main screen for graphics
    BGI_USE_HERC,				// use normal monochrome card graphics driver
    BGI_USE_MONO_PATCH,			// use patched monochrome card graphics driver
    BGI_AUTO_DETECT,			// use whatever the machine has
	BGI_SUBJECT_IS_USER			// make the experimenter the main viewer

} ScreenCombo;


/************************************************************************
** ResponseFeature
**
**		Lets the experimenter select the style of ResponseBGIInterior
** in use.  You'll have to run the program to see what these mean.
** They are implemented in the FACE_TV library, but do not appear
** as selectable options in any FACE_TV.EXE dialog box.   See how
** they're used in PSI.EXE.
**
*************************************************************************/

typedef enum
{
	RF_STANDARD			= 0,
	RF_PLAIN,
	RF_CYAN,
	RF_TEXT_WARNING

} ResponseFeature;


#endif													// } SCRCOMBO_h
