;************************************************************************
;**
;** @(#)tmtomono.asm	12/06/94	Chris Ahlstrom
;**
;**		Defines the functions monoMouseCursor() and mainMouseCursor()
;** declared in tmouse.h.
;**
;**		Note that the MODEL directive causes the underscore to be
;** added to public symbols for us.
;**
;**		THESE ROUTINES DON'T DO WHAT I THOUGHT THEY WOULD!
;**
;************************************************************************

		IDEAL
		MODEL LARGE, C

		PUBLIC monoMouseCursor
		PUBLIC mainMouseCursor

CODESEG

;************************************************************************
;**
;**		void
;**		monoMouseCursor
;**		(
;**			int page,		// put cursor on page 0 or 1
;**			int enabler		// if 1, fix up to use the cursor
;**		)
;**
;**		For the mouse graphics cursor to show on a Hercules graphics
;** board, you must poke 6 into location 40:49 hex for page 0, or 5 for
;** page 1.
;**
;**		OLD NOTES:
;**
;**	1.	We can use SI and DI without saving and restoring them.
;**
;**	2.	We get the old value at 40:49h into BL and CL.
;**
;**	3.	The original bit values (in CL) are saved for retrieval (in
;**		oldByte) after we're finished.
;**
;**	4.	We strip off the 3 low bits in BL, and replace them with the
;**		proper mask_in value.
;**
;**	5.	We put this value into 40:49h.
;**
;**	6.	Later, if we call this function again with enabler set to 0,
;**		then we get the oldByte back and stuff it into 40:49h.
;**
;**	7.	Note how we're careful when we try to access the oldByte:  we
;**		must be using the normal DS value.
;**
;**	8.	Do /not/ call monoMouseCursor(x, 0) unless the previous call to
;**		it was monoMouseCursor(x, 1) !!!
;**
;************************************************************************



oldByte		DB		0


PROC	monoMouseCursor
;
	ARG 	page : WORD
	LOCAL	mask_in : WORD
	USES	DS,SI,DI						;and AX, BX, CX, ES

	MOV		CX,[page]						;HGC page (0 or 1) to set up
	CMP		CX,1							;is it page 1?
	JE		MMC_PAGE_1						;yes

	MOV		[mask_in],0006h					;load for page 0
	JMP		SHORT MMC_SET_UP				;go to rest of setup

MMC_PAGE_1:
;
	MOV		[mask_in],0005h					;load for page 1

MMC_SET_UP:
;
	PUSH	DS								;save C/C++ segment register
	POP		ES								;save it in ES

	MOV		AX,0000h						;first part of address 40:49
	MOV		DS,AX							;this is the new segment
	MOV		SI,0449h						;second part of address 40:49
	MOV		CL,[SI]							;obtain what's already there
	MOV		AL,006h							;value for alternate monitor
	MOV		[SI],AL							;40:[49] = 014h = 20 dec
;
	PUSH	ES								;get the old DS
	POP		DS								;restore it

	MOV		[oldByte],CL					;save the old value

MMC_EXIT:
;
	RET										;return the offset
;
ENDP


PROC	mainMouseCursor
;
	USES	DS,SI,DI						;and AX, BX, CX, ES

	PUSH	DS								;save C/C++ segment register
	POP		ES								;save it in ES

	MOV		AX,0040h						;first part of address 40:49
	MOV		DS,AX							;this is the new segment
	MOV		SI,0049h						;second part of address 40:49
	MOV		CL,[SI]							;obtain what's already there
	MOV		AL,007h							;value for main monitor
	MOV		[SI],AL							;40:[49] = 014h = 20 dec
;
	MOV		SI,0463h						;not sure what this is...
	MOV		BX,03B4h						;address of HGC address register
	MOV		[SI],BX							;save it here

	PUSH	ES								;get the old DS
	POP		DS								;restore it

	MOV		[oldByte],CL					;save the old value

MAC_EXIT:
;
	RET										;return the offset
;
ENDP


END
