;************************************************************************
;**
;** @(#)ttermpln.asm	10/07/94	Chris Ahlstrom
;**
;**		Borland's Turbo Vision 1.0 module ttprvlns.asm, for use with
;** the tterminl.cpp/h module, which fixes some problems with TTerminal,
;** and creates a new class, TTerminal2.
;**
;************************************************************************

		IDEAL
		MODEL LARGE, PROLOG

		INCLUDE "TVWRITE.INC"				;the version in TV directory

		PUBLIC @TTerminal2@prevLines$qusus

CODESEG


;************************************************************************
;** DecDI
;**
;**		If DI is above "buffer", it is decremented.  Otherwise, it
;** is set to just past the end of the "buffer", and decremented.
;**
;************************************************************************

PROC	DecDI
;
		CMP 	DI,[WORD PTR SI+TTerminalBuffer]	;above the buffer start?
		JA		DECDI_1								;yes

		ADD 	DI,[WORD PTR SI+TTerminalBufSize]	;no, set to after end

DECDI_1:
;
		DEC 	DI
		RET
;
ENDP


;************************************************************************
;** IncDI
;**
;**		DI is incremented; if past the end of the buffer, then DI is
;** set to the beginning of the buffer.
;**
;************************************************************************

PROC	IncDI
;
		INC 	DI
		MOV 	AX,[WORD PTR SI+TTerminalBuffer]
		ADD 	AX,[SI+TTerminalBufSize]
		CMP 	DI,AX								;end of buffer?
		JB		INCDI_1								;no

		MOV 	DI,[WORD PTR SI+TTerminalBuffer]	;yes, set to beginning

INCDI_1:
;
		RET
;
ENDP


;************************************************************************
;** prevLines(ushort Pos, ushort Lines)
;**
;**		Returns the offset of the start of the line that is "Lines"
;** previous to the position "Pos".
;**
;************************************************************************

PROC	@TTerminal2@prevLines$qusus
;
		ARG 	thisPtr : FAR PTR, Pos : WORD, Lines : WORD
		USES	DS,SI,DI

LineSeparator	EQU 10

		LDS 	SI,[thisPtr]						;load "this"
		LES 	DI,[SI+TTerminalBuffer]				;get the buffer address
		ADD 	DI,[Pos]							;DI-->current position

PL_1:												;never referenced!
;
		MOV 	CX,[Lines]							;get Lines argument
		JCXZ	PL_NO_LINES							;if zero, jump

		MOV 	AX,[SI+TTerminalQueBack]			;queBack
		ADD 	AX,[WORD PTR SI+TTerminalBuffer]	;buffer start
;
; Because of the initial load of DI, the following result is either
; greater-than or else equal-to.
;
		CMP 	DI,AX								;current pos == back pos?
		JE		PL_7								;yes

		CALL	DecDI								;no, go back one char

PL_BACK_LINE:
;
		MOV 	AX,[SI+TTerminalQueBack]			;queBack (same as above!)
		ADD 	AX,[WORD PTR SI+TTerminalBuffer]	;buffer start
		CMP 	DI,AX								;current pos > back pos?
		JA		PL_ABOVE_BACK						;yes

		MOV 	CX,DI								;no, copy current pos
		SUB 	CX,[WORD PTR SI+TTerminalBuffer]	;convert to buffer offset
		JMP 	PL_DO_OFFSET

PL_ABOVE_BACK:
;
		MOV 	CX,DI								;copy current pos
		SUB 	CX,AX								;CX=current pos - back pos

PL_DO_OFFSET:
;
		MOV 	AL,LineSeparator					;get \n
		INC 	CX									;current pos++
		STD											;set direction flag
		REPNE	SCASB								;look backwards for \n
		JE		PL_CR_FOUND							;found it

		MOV 	AX,DI								;no \n, get current pos
		SUB 	AX,[WORD PTR SI+TTerminalBuffer]	;convert to buffer offset
		INC 	AX									;offset++
		CMP 	AX,[SI+TTerminalQueBack]			;current pos == back pos?
		JE		PL_EXIT								;yes, finished

		MOV 	DI,[WORD PTR SI+TTerminalBuffer]	;set DI...
		ADD 	DI,[WORD PTR SI+TTerminalBufSize]	;...to...
		DEC 	DI									;...end of buffer
		JMP 	PL_BACK_LINE						;do more

PL_CR_FOUND:
;
		DEC 	[Lines]								;DI at previous line
		JNZ 	PL_BACK_LINE						;do more

PL_NO_LINES:
;
		CALL	IncDI								;current pos++
		CALL	IncDI								;current pos++
		MOV 	AX,DI								;save it

PL_7:
;
		SUB 	AX,[WORD PTR SI+TTerminalBuffer]	;convert it to offset

PL_EXIT:
;
		CLD											;clear direction flag
		RET											;return the offset
;
ENDP

END
