/************************************************************************
**
** @(#)tvscreen.h		11/28/94		Chris Ahlstrom
**
** Borland C++/Turbo Vision
**
**		Note the reversal of argument order, if the caller chooses
** to use the "non-denominational" [same whether using TV or not]
** call!!!
**
*************************************************************************/

#if !defined(TVSCREEN_h)								/* { TVSCREEN_h	*/
#define TVSCREEN_h


#if !defined(USE_TURBO_VISION)
#define USE_TURBO_VISION
#endif

#define screenmsg(a, b, c)	tvScreenmsg((b), (c), (a))


extern

#ifdef __cplusplus									/* { __cplusplus	*/
"C"
#endif												/* } __cplusplus	*/

int tvScreenmsg
(
	void *handle,				// bogus for now
	const char *string,			// string to display
	int use_io = 1				// do not ignore output by default
);

#if defined(__cplusplus)							/* { __cplusplus	*/

#define Uses_TWindow
#define Uses_TApplication
#define Uses_TRect
#define Uses_MsgBox
#define Uses_TDeskTop
#include <tv.h>

#include "ttermext.h"			// TTerminalExtended class


/************************************************************************
** TWindowScreen class
**
**		Largely based on the handy TTerminal2 class provided by Borland.
** Long live Philippe Kahn!  (I'd like to see a mud-wrestling contest
** between him and Bill Gates.)
**
*************************************************************************/

#define LEFT_X		 1
#define LEFT_Y		 5
#define RIGHT_X		78
#define RIGHT_Y		22

class TWindowScreen : public TWindow
{

public:

	TWindowScreen
	(
		const TRect& bounds,	// initial size rectangle for window
		const char *atitle,		// title for the top of the frame
		short anumber,			// bogus number for the window (wmNoNumber)
		ushort bufsize			// buffer size for window
	);
	~TWindowScreen();

	TTerminalExtended *makeInterior
	(
		TRect bounds, ushort abufsize
	);
	unsigned int write
	(
		const char *filename = 0
	);
	void clear ();

	friend TWindowScreen *startWindowScreen		// see extern decl below
	(
		TDeskTop *desktop,
		unsigned buffsize,
		int leftx,
		int lefty,
		int rightx,
		int righty
	);
	friend void doScreenMessage
	(
		TWindowScreen *handle,
		const char *message
	);

private:

	TTerminalExtended *screenInterior;	// points to window interior

	/********************************************************************
	** For some reason, cannot pass the pointer "screenOStream" without
	** causing weird problems (see the unuseable code in the USEABLE_CODE
	** #if in tvscreen.cpp).
	**
	** otstream *screenOStream;	// one output text stream per interior
	**
	*********************************************************************/
};


/************************************************************************
** Friend functions of the TWindowScreen class
*************************************************************************/

extern void doScreenMessage				/* helper function				*/
(
	TWindowScreen *handle,
	const char *message
);

extern TWindowScreen *startWindowScreen	/* helper for creating screens	*/
(
	TDeskTop *desktop,
	unsigned buffsize = 64000U,
	int leftx	= LEFT_X,
	int lefty	= LEFT_Y,
	int rightx	= RIGHT_X,
	int righty	= RIGHT_Y
);

#endif												/* } __cplusplus	*/

#endif													/* } TVSCREEN_h	*/
